<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;

class Fidelidade {
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}

	public function carregaCampanhasEspecificaProduto($CDCAMPANHA, $IDCAMPANHA) {
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA,
			':IDCAMPANHA' => $IDCAMPANHA
		);		

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::CARREGA_CAMPANHAS_ESP_PRODUTO, $params);		
	}

	public function carregaCampanhasEspecificaDotz($CDCAMPANHA, $IDCAMPANHA) {
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA,
			':IDCAMPANHA' => $IDCAMPANHA
		);	

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::CARREGA_CAMPANHAS_ESP_DOTZ, $params);		
	}

	public function carregaCampanhasEspecificaDesconto($CDCAMPANHA, $IDCAMPANHA) {
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA,
			':IDCAMPANHA' => $IDCAMPANHA
		);	

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::CARREGA_CAMPANHAS_ESP_DESCONTO, $params);		
	}

	public function carregaCampanhasEspecificaBeneficio($CDCAMPANHA, $IDCAMPANHA){
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA,
			':IDCAMPANHA' => $IDCAMPANHA
		);	

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::CARREGA_CAMPANHAS_ESP_BENEFICIO, $params);
	}

	public function carregaCampanhasProduto($IDCAMPANHA) {
		$params = array(
			':IDCAMPANHA' => $IDCAMPANHA
		);		

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::CARREGA_CAMPANHAS_PRODUTO, $params);		
	}

	public function carregaCampanhasDotz($IDCAMPANHA) {
		$params = array(
			':IDCAMPANHA' => $IDCAMPANHA
		);		

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::CARREGA_CAMPANHAS_DOTZ, $params);		
	}

	public function carregaCampanhasDesconto($IDCAMPANHA) {
		$params = array(
			':IDCAMPANHA' => $IDCAMPANHA
		);		

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::CARREGA_CAMPANHAS_DESCONTO, $params);		
	}

	public function tiposCampanha() {		
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::TIPOS_CAMPANHA);
	}	

	public function registrarCampanha($CDCAMPANHA, $DSCAMPANHA, $CDTPCAMPANHA, $DTINIVIGCAMP, $DTFIMVIGCAMP, $IDCAMPANHA, $NRDIASVALPONTO, $IDUTILVOUCHER, $VRPONTOVOUCHER, $NRDIAVALVOUCHER, $CDOPERULTATU, $CDOPERINCLUSAO, $NRORG, $IDPONTUACAOCAMP, $CDPROMOCAODOTZ, $VRPESOCAMP, $VRPONTOCAMP, $VRVENDAINIDOTZ, $VRVENDAFINDOTZ){
		$params = array(
			':CDCAMPANHA'		=> $CDCAMPANHA,
			':DSCAMPANHA' 	 	=> $DSCAMPANHA, 
			':CDTPCAMPANHA' 	=> $CDTPCAMPANHA, 
			':DTINIVIGCAMP' 	=> $DTINIVIGCAMP, 
			':DTFIMVIGCAMP' 	=> $DTFIMVIGCAMP, 
			':IDCAMPANHA' 	 	=> $IDCAMPANHA, 
			':NRDIASVALPONTO' 	=> $NRDIASVALPONTO, 
			':IDUTILVOUCHER'  	=> $IDUTILVOUCHER, 
			':VRPONTOVOUCHER' 	=> $VRPONTOVOUCHER, 
			':NRDIAVALVOUCHER'	=> $NRDIAVALVOUCHER,
			':CDOPERULTATU'		=> $CDOPERULTATU,
			':CDOPERINCLUSAO' 	=> $CDOPERINCLUSAO,
			':NRORG'			=> $NRORG, 
			':IDPONTUACAOCAMP'	=> $IDPONTUACAOCAMP,
			':CDPROMOCAODOTZ' 	=> $CDPROMOCAODOTZ, 
			':VRPESOCAMP' 		=> $VRPESOCAMP, 
			':VRPONTOCAMP' 		=> $VRPONTOCAMP, 
			':VRVENDAINIDOTZ' 	=> $VRVENDAINIDOTZ, 
			':VRVENDAFINDOTZ' 	=> $VRVENDAFINDOTZ
		);
		
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::REGISTRAR_CAMPANHA, $params);	
	}

	public function inserirFilial($CDCAMPANHA, $CDFILIAL, $NRORG, $NRORGINCLUSAO, $CDOPERINCLUSAO, $NRORGULTATU, $CDOPERULTATU){
		$params = array(
			':CDCAMPANHA' 	 	=> $CDCAMPANHA, 
			':CDFILIAL'	  	 	=> $CDFILIAL, 
			':NRORG' 	  	 	=> $NRORG,			
			':NRORGINCLUSAO' 	=> $NRORGINCLUSAO, 
			':CDOPERINCLUSAO'	=> $CDOPERINCLUSAO, 
			':NRORGULTATU'		=> $NRORGULTATU, 
			':CDOPERULTATU'		=> $CDOPERULTATU
		);								
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::CAD_FILIAL_CAMPANHA, $params);
	}	

	public function incluirProduto($CDCAMPANHA, $NRSEQPRODCAMP, $CDPRODUTO, $IDPRODUTOGERA, $VRPONTOPROD, $DTINIVIGPROD, $DTFIMVIGPROD, $NRORG, $NRORGINCLUSAO, $CDOPERINCLUSAO, $NRORGULTATU, $CDOPERULTATU){

		$params = array(
			':CDCAMPANHA' 	 	=> $CDCAMPANHA,
			':NRSEQPRODCAMP' 	=> $NRSEQPRODCAMP,  
			':CDPRODUTO'	  	=> $CDPRODUTO, 
			':IDPRODUTOGERA' 	=> $IDPRODUTOGERA, 
			':VRPONTOPROD' 		=> $VRPONTOPROD, 
			':DTINIVIGPROD' 	=> $DTINIVIGPROD, 
			':DTFIMVIGPROD' 	=> $DTFIMVIGPROD,
			':NRORG' 	  	 	=> $NRORG,			
			':NRORGINCLUSAO' 	=> $NRORGINCLUSAO, 
			':CDOPERINCLUSAO'	=> $CDOPERINCLUSAO, 
			':NRORGULTATU'		=> $NRORGULTATU, 
			':CDOPERULTATU'		=> $CDOPERULTATU
		);		
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERE_PROD_CAMPANHA, $params);				
	}

	public function alterarProduto($CDCAMPANHA, $NRSEQPRODCAMP, $CDPRODUTO, $IDPRODUTOGERA, $VRPONTOPROD, $DTINIVIGPROD, $DTFIMVIGPROD, $NRORG, $NRORGINCLUSAO, $NRORGULTATU, $CDOPERULTATU){
		$params = array(
			':CDCAMPANHA' 	 	=> $CDCAMPANHA,
			':NRSEQPRODCAMP' 	=> $NRSEQPRODCAMP,  
			':CDPRODUTO'	  	=> $CDPRODUTO, 
			':IDPRODUTOGERA' 	=> $IDPRODUTOGERA, 
			':VRPONTOPROD' 		=> $VRPONTOPROD, 
			':DTINIVIGPROD' 	=> $DTINIVIGPROD, 
			':DTFIMVIGPROD' 	=> $DTFIMVIGPROD,
			':NRORG' 	  	 	=> $NRORG,			
			':NRORGINCLUSAO' 	=> $NRORGINCLUSAO,			 
			':NRORGULTATU'		=> $NRORGULTATU, 
			':CDOPERULTATU'		=> $CDOPERULTATU
		);		
			
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ATUALIZA_PROD_CAMPANHA, $params);
	}

	public function inserirBrinde($CDPRODUTO, $DSBRINDE, $VRPONTOBRINDE, $CDCAMPANHA, $NRORG, $NRORGINCLUSAO, $CDOPERINCLUSAO, $NRORGULTATU, $CDOPERULTATU){				
		$params = array(
			':CDPRODUTO' 		=> $CDPRODUTO, 
			':DSBRINDE'		 	=> $DSBRINDE, 
			':VRPONTOBRINDE' 	=> $VRPONTOBRINDE, 
			':CDCAMPANHA' 	 	=> $CDCAMPANHA, 
			':NRORG' 		 	=> $NRORG, 
			':NRORGINCLUSAO' 	=> $NRORGINCLUSAO, 
			':CDOPERINCLUSAO'	=> $CDOPERINCLUSAO, 
			':NRORGULTATU' 		=> $NRORGULTATU, 
			':CDOPERULTATU' 	=> $CDOPERULTATU
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERE_BRINDE_CAMPANHA, $params);
	}

	public function alterarBrinde($CDPRODUTO, $DSBRINDE, $VRPONTOBRINDE, $CDCAMPANHA, $NRORG, $NRORGINCLUSAO, $NRORGULTATU, $CDOPERULTATU){
		$params = array(
			':CDPRODUTO' 		=> $CDPRODUTO, 
			':DSBRINDE'		 	=> $DSBRINDE, 
			':VRPONTOBRINDE' 	=> $VRPONTOBRINDE, 
			':CDCAMPANHA' 	 	=> $CDCAMPANHA, 
			':NRORG' 		 	=> $NRORG, 
			':NRORGINCLUSAO' 	=> $NRORGINCLUSAO,			
			':NRORGULTATU' 		=> $NRORGULTATU, 
			':CDOPERULTATU' 	=> $CDOPERULTATU
		);		

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ATUALIZA_BRINDE_CAMPANHA, $params);
	}

	public function buscaFiliaisCampanha($CDCAMPANHA){
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA			
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_FILIAIS_CAMPANHA, $params);
	}

	public function buscaProdutosCampanha($CDCAMPANHA){
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA			
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_PRODUTOS_CAMPANHA, $params);	
	}

	public function buscaBrindesCampanha($CDCAMPANHA){
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA			
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_BRINDES_CAMPANHA, $params);				
	}

	public function  alterarCampanha($CDCAMPANHA, $CDTPCAMPANHA, $DSCAMPANHA, $DTFIMVIGCAMP, $DTINIVIGCAMP, $IDUTILVOUCHER, $NMTPCAMPANHA, $NRDIASVALPONTO, $NRDIAVALVOUCHER, $VRPONTOVOUCHER, $CDPROMOCAODOTZ, $VRPESOCAMP, $VRPONTOCAMP, $VRVENDAINIDOTZ, $VRVENDAFINDOTZ, $NRORG, $NRORGINCLUSAO, $CDOPERINCLUSAO, $NRORGULTATU, $CDOPERULTATU, $IDCAMPANHA){
				
		$params = array(
			':CDCAMPANHA' 		=> $CDCAMPANHA,      
			':CDTPCAMPANHA' 	=> $CDTPCAMPANHA,
			':DSCAMPANHA' 		=> $DSCAMPANHA,
			':DTFIMVIGCAMP' 	=> $DTFIMVIGCAMP,
			':DTINIVIGCAMP' 	=> $DTINIVIGCAMP,
			':IDUTILVOUCHER' 	=> $IDUTILVOUCHER,
			':NMTPCAMPANHA' 	=> $NMTPCAMPANHA,
			':NRDIASVALPONTO' 	=> $NRDIASVALPONTO,
			':NRDIAVALVOUCHER' 	=> $NRDIAVALVOUCHER,
			':VRPONTOVOUCHER'   => $VRPONTOVOUCHER,  
			':CDPROMOCAODOTZ' 	=> $CDPROMOCAODOTZ,  
			':VRPESOCAMP' 		=> $VRPESOCAMP,      
			':VRPONTOCAMP' 		=> $VRPONTOCAMP,     
			':VRVENDAINIDOTZ' 	=> $VRVENDAINIDOTZ,  
			':VRVENDAFINDOTZ' 	=> $VRVENDAFINDOTZ, 
			':NRORG' 			=> $NRORG,           
			':NRORGINCLUSAO' 	=> $NRORGINCLUSAO,
			':CDOPERINCLUSAO' 	=> $CDOPERINCLUSAO,
			':NRORGULTATU' 		=> $NRORGULTATU,
			':CDOPERULTATU' 	=> $CDOPERULTATU,
			':IDCAMPANHA'		=> $IDCAMPANHA
		);				

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ALTERAR_CAMPANHA, $params);
	}

	public function deleteFilialCampanha($CDCAMPANHA, $CDFILIAL){
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA,
			':CDFILIAL'	  => $CDFILIAL					
		);
				
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_FILIAL_CAMPANHA, $params);	
	}

	public function deleteProdCamapanha($CDCAMPANHA, $CDPRODUTO){
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA,
			':CDPRODUTO'  => $CDPRODUTO
		);		

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_PRODUTO_CAMPANHA, $params);	
	}

	public function deleteBrindeCamapanha($CDCAMPANHA, $CDPRODUTO){
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA,
			':CDPRODUTO'  => $CDPRODUTO					
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_BRINDE_CAMPANHA, $params);		
	}

	public function buscaFilialCampanha($CDFILIAL){
		$params = array(			
			':CDFILIAL'	  => $CDFILIAL					
		);
		
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_FILIAL_CAMPANHA, $params);
	}

	public function buscaProdCampanha($CDCAMPANHA, $CDPRODUTO){
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA,
			':CDPRODUTO'  => $CDPRODUTO			
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_PROD_CAMPANHA, $params);
	}

	public function buscaBrindeCampanha($CDCAMPANHA, $CDPRODUTO){
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA,
			':CDPRODUTO'  => $CDPRODUTO			
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_BRINDE_CAMPANHA, $params);
	}	

	public function cadTipoCampanha($CDTPCAMPANHA, $NMTPCAMPANHA, $NRORG, $NRORGINCLUSAO, $CDOPERINCLUSAO, $NRORGULTATU, $CDOPERULTATU){
		$params = array(
			':CDTPCAMPANHA'	  => $CDTPCAMPANHA,
			':NMTPCAMPANHA'   => $NMTPCAMPANHA, 
			':NRORG' 		  => $NRORG, 
			':NRORGINCLUSAO'  => $NRORGINCLUSAO, 
			':CDOPERINCLUSAO' => $CDOPERINCLUSAO, 
			':NRORGULTATU' 	  => $NRORGULTATU, 
			':CDOPERULTATU'   => $CDOPERULTATU
		);		

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::CAD_TIPO_CAMPANHA, $params);
	}	

	public function deletarTodosBrindes($CDCAMPANHA){
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA			
		);		

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETAR_TODOS_BRINDES, $params);
	}

	public function deletarTodosProdutos($CDCAMPANHA){
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA			
		);		

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETAR_TODOS_PRODUTOS, $params);
	}

	public function deletarTodasFiliais($CDCAMPANHA){
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA			
		);		

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETAR_TODAS_FILIAIS, $params);
	}

	public function deletarCampanha($CDCAMPANHA){
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA			
		);		

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETAR_CAMPANHA, $params);
	}

	public function alterarTipoCampanha($CDTPCAMPANHA, $NMTPCAMPANHA){
		$params = array(
			':CDTPCAMPANHA' => $CDTPCAMPANHA,
			':NMTPCAMPANHA' => $NMTPCAMPANHA
		);		

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ALTERAR_TIPO_CAMPANHA, $params);
	}

	public function deleteTpCampanha($CDTPCAMPANHA){
		$params = array(
			':CDTPCAMPANHA' => $CDTPCAMPANHA
		);		

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_TIPO_CAMPANHA, $params);
	}

	public function verificaUtilTPCampanha($CDTPCAMPANHA){
		$params = array(
			':CDTPCAMPANHA' => $CDTPCAMPANHA
		);		

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::VERIFICA_UTIL_TPCAMPANHA, $params);
	}

	public function todasCampanhas(){
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_TODAS_CAMPANHAS);
	}

	public function filtrarMovimento($CDCAMPANHA, $CDCLIENTE, $CDCONSUMIDOR, $IDCAMPANHA){
		$params = array(			 
			':CDCAMPANHA' 	=> $CDCAMPANHA, 
			':CDCLIENTE' 	=> $CDCLIENTE, 
			':CDCONSUMIDOR' => $CDCONSUMIDOR,			
			':IDCAMPANHA'	=> $IDCAMPANHA
		);		
		
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_MOVIMENTO, $params);
	}

	public function filtrarMovimentoBeneficio($CDCAMPANHA, $CDCLIENTE, $CDCONSUMIDOR){
		$params = array(			 
			':CDCAMPANHA' 	=>$CDCAMPANHA, 
			':CDCLIENTE' 	=>$CDCLIENTE, 
			':CDCONSUMIDOR' =>$CDCONSUMIDOR
		);
		
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_MOVIMENTO_BENEFICIO, $params);
	}

	public function filtrarMovData($CDCAMPANHA, $CDCLIENTE, $CDCONSUMIDOR, $IDCAMPANHA, $DTINICIO){
		$params = array(
			':CDCAMPANHA' 	=> $CDCAMPANHA, 
			':CDCLIENTE' 	=> $CDCLIENTE, 
			':CDCONSUMIDOR' => $CDCONSUMIDOR, 
			':IDCAMPANHA' 	=> $IDCAMPANHA, 
			':DTINICIO' 	=> $DTINICIO
		);		

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_MOVIMENTO_DATA, $params);
	}

	public function gravarManutencao($CDCAMPANHA, $CDCLIENTE, $CDCONSUMIDOR, $IDTPMOVCONS, $VRMOVPONTOCONS, $VRSALDOCONS, $NRSEQMOVCONS, $DSOBSMOVPTOCONS, $DTVALIDAPONTO, $NRORG, $NRORGINCLUSAO, $NRORGULTATU, $CDOPERULTATU, $CDOPERINCLUSAO){		 		

		 $params = array(
			 ':CDCAMPANHA' 		=> $CDCAMPANHA, 
			 ':CDCLIENTE' 		=> $CDCLIENTE, 
			 ':CDCONSUMIDOR' 	=> $CDCONSUMIDOR, 
			 ':IDTPMOVCONS' 	=> $IDTPMOVCONS, 
			 ':VRMOVPONTOCONS' 	=> $VRMOVPONTOCONS,			 
			 ':VRSALDOCONS'		=> $VRSALDOCONS,
			 ':NRSEQMOVCONS'	=> $NRSEQMOVCONS,
			 ':DSOBSMOVPTOCONS' => $DSOBSMOVPTOCONS, 
			 ':DTVALIDAPONTO' 	=> $DTVALIDAPONTO, 
			 ':NRORG' 			=> $NRORG, 
			 ':NRORGINCLUSAO' 	=> $NRORGINCLUSAO, 
			 ':NRORGULTATU' 	=> $NRORGULTATU,
			 ':CDOPERULTATU'	=> $CDOPERULTATU, 
			 ':CDOPERINCLUSAO'	=> $CDOPERINCLUSAO

		);
		
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::GRAVAR_MANUTENCAO, $params);
	}	

	public function carregaVouchers($CDCAMPANHA, $CDCLIENTE, $CDCONSUMIDOR){
		$params = array(
			':CDCAMPANHA' 	=> $CDCAMPANHA, 
			':CDCLIENTE' 	=> $CDCLIENTE, 
			':CDCONSUMIDOR' => $CDCONSUMIDOR			
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::CARREGA_VOUCHERS, $params);				
	}

	public function creditomaisAntigo($CDCAMPANHA, $CDCLIENTE, $CDCONSUMIDOR){
		$params = array(
			':CDCAMPANHA' 	=> $CDCAMPANHA,			 
			':CDCLIENTE'  	=> $CDCLIENTE, 
			':CDCONSUMIDOR' => $CDCONSUMIDOR
		);
		
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::CREDITO_MAIS_ANTIGO, $params);
				
	}

	public function atualizaVRSALDOCONS($CDCAMPANHA, $CDCLIENTE, $CDCONSUMIDOR, $NRSEQMOVCONS, $VRSALDOCONS){
		$params = array(
			':CDCAMPANHA' 	=> $CDCAMPANHA,			 
			':CDCLIENTE'  	=> $CDCLIENTE, 
			':CDCONSUMIDOR' => $CDCONSUMIDOR,
			':NRSEQMOVCONS' => $NRSEQMOVCONS, 
			':VRSALDOCONS' 	=> $VRSALDOCONS
		);
		
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ATUALIZA_VRSALDOCONS, $params);
	}

	public function buscaSaldo($CDCAMPANHA, $CDCLIENTE, $CDCONSUMIDOR){
		$params = array(
			':CDCAMPANHA' 	=> $CDCAMPANHA,			
			':CDCLIENTE' 	=> $CDCLIENTE,
			':CDCONSUMIDOR' => $CDCONSUMIDOR
		);				
		
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_SALDO, $params);
	}

	public function qtdConumidores($CDCAMPANHA){
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA			
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::QTD_CONS_CAMPANHA, $params);
	}

	public function dadosCampanha($CDCAMPANHA){
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA			
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::DADOS_CAMPANHA, $params);
	}

	public function vrtotvendas($CDCAMPANHA, $DTINIVIGCAMP, $DTFIMVIGCAMP){
		$params = array(
			':CDCAMPANHA'   => $CDCAMPANHA,
			':DTINIVIGCAMP' => $DTINIVIGCAMP,
			':DTFIMVIGCAMP' => $DTFIMVIGCAMP
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_VRTOTVENDAS, $params);
	}

	public function dadosBeneficio($CDCAMPANHA, $DTINIVIGCAMP, $DTFIMVIGCAMP, $NRCONSUMIDORES){
		$params = array(
			':CDCAMPANHA'     => $CDCAMPANHA,
			':DTINIVIGCAMP'   => $DTINIVIGCAMP,
			':DTFIMVIGCAMP'   => $DTFIMVIGCAMP,
			':NRCONSUMIDORES' => $NRCONSUMIDORES
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::DADOS_BENEFICIO, $params);
	}

	public function dadosResgBrinde($CDCAMPANHA, $DTINIVIGCAMP, $DTFIMVIGCAMP){
		$params = array(
			':CDCAMPANHA'   => $CDCAMPANHA,
			':DTINIVIGCAMP' => $DTINIVIGCAMP,
			':DTFIMVIGCAMP' => $DTFIMVIGCAMP
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::DADOS_RESG_BRINDE, $params);
	}	

	public function buscaBrindesResgatados($CDCAMPANHA, $DTINIVIGCAMP, $DTFIMVIGCAMP){
		$params = array(
			':CDCAMPANHA'   => $CDCAMPANHA,
			':DTINIVIGCAMP' => $DTINIVIGCAMP,
			':DTFIMVIGCAMP' => $DTFIMVIGCAMP
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::DADOS_BRINDES_RESGATADOS, $params);
	}

	public function buscaVigCamp($CDCAMPANHA){
		$params = array(
			':CDCAMPANHA'   => $CDCAMPANHA			
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_VIGENCIA_CAMPANHA, $params);
	}

	public function buscaCampanhaBrinde($CDCLIENTE, $CDCONSUMIDOR){
		$params = array(
			':CDCLIENTE'   => $CDCLIENTE, 
			':CDCONSUMIDOR' => $CDCONSUMIDOR
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_CAMPANHA_BRINDE_MANUTENCAO, $params);
	}

	public function buscaCampanhaBeneficios($CDCLIENTE, $CDCONSUMIDOR, $NRORG){
		$params = array(
			':CDCLIENTE'    => $CDCLIENTE, 
			':CDCONSUMIDOR' => $CDCONSUMIDOR,
			':NRORG'		=> $NRORG
		);

		return $this->entityManager->getConnection()->fetchAll(self::BUSCA_CAMPANHA_BENEFICIOS_MANUTENCAO, $params);
	}

	public function buscaCampanhaDesconto($CDCLIENTE, $CDCONSUMIDOR){
		$params = array(
			':CDCLIENTE'   => $CDCLIENTE, 
			':CDCONSUMIDOR' => $CDCONSUMIDOR
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_CAMPANHA_DESCONTO_MANUTENCAO, $params);
	}

	public function buscaBeneficios(){
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_BENEFICIOS);
	}

	public function buscaBeneficio($NRSEQBENEFICIO){
		$params = array(
			':NRSEQBENEFICIO' 		=> $NRSEQBENEFICIO
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_BENEFICIO, $params);
	}

	public function cadBeneficio($NRSEQBENEFICIO, $IDTPBENEFICIO, $VRBENEFICIO, $IDTPATIVABENEFICIO, $NRORG, $NRORGINCLUSAO, $CDOPERINCLUSAO, $NRORGULTATU, $CDOPERULTATU, $DSBENEFICIO, $QTDMAXDIACOMPRA, $QTDMAXDIASUBSEQ){
		$params = array(
			':NRSEQBENEFICIO' 		=> $NRSEQBENEFICIO, 
			':IDTPBENEFICIO' 		=> $IDTPBENEFICIO, 
			':VRBENEFICIO' 			=> $VRBENEFICIO, 
			':IDTPATIVABENEFICIO' 	=> $IDTPATIVABENEFICIO, 
			':NRORG' 				=> $NRORG,			
			':NRORGINCLUSAO' 		=> $NRORGINCLUSAO, 
			':CDOPERINCLUSAO' 		=> $CDOPERINCLUSAO, 
			':NRORGULTATU' 			=> $NRORGULTATU, 
			':CDOPERULTATU' 		=> $CDOPERULTATU,
			':DSBENEFICIO'			=> $DSBENEFICIO,
			':QTDMAXDIACOMPRA' 		=> $QTDMAXDIACOMPRA,
			':QTDMAXDIASUBSEQ' 		=> $QTDMAXDIASUBSEQ
		);			

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::CAD_BENEFICIO, $params);
	}

	public function alterarBeneficio($NRSEQBENEFICIO, $IDTPBENEFICIO, $VRBENEFICIO, $IDTPATIVABENEFICIO, $NRORG, $NRORGINCLUSAO, $CDOPERINCLUSAO, $NRORGULTATU, $CDOPERULTATU, $DSBENEFICIO, $QTDMAXDIACOMPRA, $QTDMAXDIASUBSEQ){
		$params = array(
			':NRSEQBENEFICIO' 		=> $NRSEQBENEFICIO,
			':IDTPBENEFICIO' 		=> $IDTPBENEFICIO, 
			':VRBENEFICIO' 			=> $VRBENEFICIO, 
			':IDTPATIVABENEFICIO' 	=> $IDTPATIVABENEFICIO, 
			':NRORG' 				=> $NRORG,			
			':NRORGINCLUSAO' 		=> $NRORGINCLUSAO, 
			':CDOPERINCLUSAO' 		=> $CDOPERINCLUSAO, 
			':NRORGULTATU' 			=> $NRORGULTATU, 
			':CDOPERULTATU' 		=> $CDOPERULTATU,
			':DSBENEFICIO' 			=> $DSBENEFICIO,
			':QTDMAXDIACOMPRA' 		=> $QTDMAXDIACOMPRA,
			':QTDMAXDIASUBSEQ' 		=> $QTDMAXDIASUBSEQ
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ALT_BENEFICIO, $params);
	}

	public function deletarBeneficio($NRSEQBENEFICIO){
		$params = array(
			':NRSEQBENEFICIO' => $NRSEQBENEFICIO
		);		

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETAR_BENEFICIO, $params);
	}

	public function verificarUtilbeneficio($NRSEQBENEFICIO){
		$params = array(
			':NRSEQBENEFICIO' => $NRSEQBENEFICIO
		);		

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::VERIFICAR_UTIL_BENEFICIO, $params);
	}

	public function buscaCampanhaBeneficio(){
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_CAMPANHA_BENEFICIO);
	}

	public function buscaNRSEQPRODCAMP($CDCAMPANHA, $CDPRODUTO){
		$params = array(
			'CDCAMPANHA' => $CDCAMPANHA, 
			'CDPRODUTO'  => $CDPRODUTO
		);		

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_NRSEQPRODCAMP, $params);
	}

	public function buscaBeneficiosCampanha($CDCAMPANHA, $NRSEQPRODCAMP){
		$params = array(
			'CDCAMPANHA' 	 => $CDCAMPANHA, 
			'NRSEQPRODCAMP'  => $NRSEQPRODCAMP
		);		

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_BENEFICIO_CAMPANHA, $params);
	}

	public function cadBeneficioCampanha($CDCAMPANHA, $NRSEQBENEFICIO, $NRSEQPRODCAMP, $NRDIASVALBENECAMP, $QTBENEFICIOCAMP, $NRORG, $NRORGINCLUSAO, $CDOPERINCLUSAO, $NRORGULTATU, $CDOPERULTATU){
		$params = array(
			':CDCAMPANHA' 			=> $CDCAMPANHA, 
			':NRSEQBENEFICIO' 		=> $NRSEQBENEFICIO, 
			':NRSEQPRODCAMP' 		=> $NRSEQPRODCAMP, 
			':NRDIASVALBENECAMP' 	=> $NRDIASVALBENECAMP, 
			':QTBENEFICIOCAMP' 		=> $QTBENEFICIOCAMP,			
			':NRORG' 				=> $NRORG, 
			':NRORGINCLUSAO' 		=> $NRORGINCLUSAO, 
			':CDOPERINCLUSAO'	 	=> $CDOPERINCLUSAO, 
			':NRORGULTATU' 			=> $NRORGULTATU, 
			':CDOPERULTATU' 		=> $CDOPERULTATU
		);		

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::CADASTRO_BENEFICIO_CAMPANHA, $params);
	}

	public function verificaUsobeneCamp($CDCAMPANHA, $NRSEQPRODCAMP, $NRSEQBENEFICIO){
		$params = array(
			':CDCAMPANHA' 	  => $CDCAMPANHA,			
			':NRSEQPRODCAMP'  => $NRSEQPRODCAMP,
			':NRSEQBENEFICIO' => $NRSEQBENEFICIO			
		);		

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::VERIFICA_UTIL_BENECAMP, $params);	
	}

	public function buscaProdBeneficio($CDCAMPANHA, $NRSEQBENEFICIO, $NRSEQPRODCAMP){
		$params = array(
			':CDCAMPANHA' 		=> $CDCAMPANHA, 
			':NRSEQBENEFICIO' 	=> $NRSEQBENEFICIO, 
			':NRSEQPRODCAMP' 	=> $NRSEQPRODCAMP
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_PROD_BENEFICIO, $params);	
	}

	public function cadProdBeneCamp($CDCAMPANHA, $NRSEQPRODCAMP, $NRSEQBENEFICIO, $CDPRODUTO, $NRORG, $NRORGINCLUSAO, $CDOPERINCLUSAO, $NRORGULTATU, $CDOPERULTATU){
		$params = array(
			':CDCAMPANHA' 		=> $CDCAMPANHA, 
			':NRSEQPRODCAMP' 	=> $NRSEQPRODCAMP, 
			':NRSEQBENEFICIO' 	=> $NRSEQBENEFICIO, 
			':CDPRODUTO' 		=> $CDPRODUTO, 
			':NRORG' 			=> $NRORG, 
			':NRORGINCLUSAO' 	=> $NRORGINCLUSAO,
			':CDOPERINCLUSAO' 	=> $CDOPERINCLUSAO, 
			':NRORGULTATU' 		=> $NRORGULTATU, 
			':CDOPERULTATU' 	=> $CDOPERULTATU
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::CAD_PROD_BENE_CAMP, $params);
	}

	public function deletarProdBeneCamp($CDCAMPANHA, $CDPRODUTO, $NRSEQBENEFICIO, $NRSEQPRODCAMP){
		$params = array(
			':CDCAMPANHA' 	  => $CDCAMPANHA, 
			':CDPRODUTO' 	  => $CDPRODUTO, 
			':NRSEQBENEFICIO' => $NRSEQBENEFICIO, 
			':NRSEQPRODCAMP'  => $NRSEQPRODCAMP
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DEL_PROD_BENE_CAMP, $params);
	}

	public function verificaProdBeneCamp($CDCAMPANHA, $NRSEQPRODCAMP, $NRSEQBENEFICIO, $CDPRODUTO){
		$params = array(
			':CDCAMPANHA' 	  => $CDCAMPANHA, 
			':NRSEQPRODCAMP'  => $NRSEQPRODCAMP,
			':NRSEQBENEFICIO' => $NRSEQBENEFICIO, 			
			':CDPRODUTO' 	  => $CDPRODUTO
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_PRODBENECAMP, $params);	
	}

	public function verificaBENEFICIOCAMP($NRSEQPRODCAMP, $CDCAMPANHA){
		$params = array(
			':NRSEQPRODCAMP' => $NRSEQPRODCAMP,
			':CDCAMPANHA' 	 => $CDCAMPANHA
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::VERIFICA_BENEFICIOCAMP, $params);	
	}

	public function deletarBeneficioCamp($CDCAMPANHA, $NRSEQBENEFICIO, $NRSEQPRODCAMP){
		$params = array(
			':CDCAMPANHA' 		=> $CDCAMPANHA, 
			':NRSEQBENEFICIO' 	=> $NRSEQBENEFICIO, 
			':NRSEQPRODCAMP' 	=> $NRSEQPRODCAMP
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DEL_BENEFICIO_CAMP, $params);
	}

	public function verificaProdutoComBeneficio($CDCAMPANHA, $NRSEQPRODCAMP, $NRSEQBENEFICIO){
		$params = array(
			':CDCAMPANHA' 		=> $CDCAMPANHA, 
			':NRSEQBENEFICIO' 	=> $NRSEQBENEFICIO, 
			':NRSEQPRODCAMP' 	=> $NRSEQPRODCAMP
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::VERIFICA_PRODUTO_COM_BENEFICIO, $params);	
	}

	public function altBeneficioCampanha($CDCAMPANHA, $NRSEQBENEFICIO, $NRSEQPRODCAMP, $NRDIASVALBENECAMP, $QTBENEFICIOCAMP, $NRORGULTATU, $CDOPERULTATU){
		$params = array(
			':CDCAMPANHA' 		 => $CDCAMPANHA, 
			':NRSEQBENEFICIO' 	 => $NRSEQBENEFICIO, 
			':NRSEQPRODCAMP' 	 => $NRSEQPRODCAMP, 
			':NRDIASVALBENECAMP' => $NRDIASVALBENECAMP, 
			':QTBENEFICIOCAMP' 	 => $QTBENEFICIOCAMP, 
			':NRORGULTATU' 		 => $NRORGULTATU, 
			':CDOPERULTATU' 	 => $CDOPERULTATU
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ALT_BENEFICIO_CAMP, $params);
	}

	public function qtdConumidoresCampBeneficio($CDCAMPANHA){
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA			
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::QTD_CONS_CAMP_BENEFICIO, $params);		
	}

	public function vrtotvendasCampBeneficio($CDCAMPANHA, $DTINIVIGCAMP, $DTFIMVIGCAMP){
		$params = array(
			':CDCAMPANHA' 	=> $CDCAMPANHA, 
			':DTINIVIGCAMP' => $DTINIVIGCAMP, 
			':DTFIMVIGCAMP' => $DTFIMVIGCAMP
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_VRTOTVENDAS_CAMPBENEFICIO, $params);
	}

	public function dadosBeneficioCampBeneficio($CDCAMPANHA, $DTINIVIGCAMP, $DTFIMVIGCAMP, $NRCONSUMIDORES){
		$params = array(
			':CDCAMPANHA'     => $CDCAMPANHA, 
			':DTINIVIGCAMP'   => $DTINIVIGCAMP, 
			':DTFIMVIGCAMP'   => $DTFIMVIGCAMP, 
			':NRCONSUMIDORES' => $NRCONSUMIDORES
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::DADOS_BENEFICIO_CAMPBENEFICIO, $params);
	}

	public function buscaBeneficioUtilizado($CDCAMPANHA, $CDCONSUMIDOR, $CDCLIENTE){
		$params = array(
			':CDCAMPANHA'   => $CDCAMPANHA, 
			':CDCONSUMIDOR' => $CDCONSUMIDOR,
			':CDCLIENTE' 	=> $CDCLIENTE
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_BENEFICIO_UTILIZADO, $params);		
	}

	public function buscaBeneficioNaoUtilizado($CDCAMPANHA, $CDCONSUMIDOR, $CDCLIENTE){
		$params = array(
			':CDCAMPANHA'   => $CDCAMPANHA, 
			':CDCONSUMIDOR' => $CDCONSUMIDOR,
			':CDCLIENTE' 	=> $CDCLIENTE
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_BENEFICIO_NAO_UTILIZADO, $params);
	}

	public function buscaQtdBeneUtil($CDCAMPANHA){
		$params = array(
			':CDCAMPANHA'   => $CDCAMPANHA
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_QTD_BENE_UTIL, $params);
	}

	public function buscaQtdBeneNaoUtil($CDCAMPANHA){
		$params = array(
			':CDCAMPANHA'   => $CDCAMPANHA
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_QTD_BENE_NAO_UTIL, $params);
	}

	public function buscaTotalDescCampanha($CDCAMPANHA){
		$params = array(
			':CDCAMPANHA'   => $CDCAMPANHA
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_TOTDESCCAMP, $params);
	}

	public function buscaBeneficioCampanha($CDCAMPANHA){
		$params = array(
			':CDCAMPANHA'   => $CDCAMPANHA
		);
		
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_BENEFICIOCAMP, $params);		
	}	

	public function insereDataUtilBeneficio($NRSEQBENECONS, $CDCLIENTE, $CDCONSUMIDOR, $CDCAMPANHA, $NRSEQPRODCAMP, $DTUTBENECONS, $NRSEQBENEFICIO, $NRORG, $NRORGINCLUSAO, $CDOPERINCLUSAO, $NRORGULTATU, $CDOPERULTATU){
		$params = array(
			':NRSEQBENECONS' 	=>$NRSEQBENECONS,
			':CDCLIENTE' 		=>$CDCLIENTE, 
			':CDCONSUMIDOR' 	=>$CDCONSUMIDOR, 
			':CDCAMPANHA' 		=>$CDCAMPANHA, 
			':NRSEQPRODCAMP' 	=>$NRSEQPRODCAMP,			 
			':DTUTBENECONS' 	=>$DTUTBENECONS, 
			':NRSEQBENEFICIO' 	=>$NRSEQBENEFICIO, 
			':NRORG' 			=>$NRORG, 
			':NRORGINCLUSAO' 	=>$NRORGINCLUSAO, 
			':CDOPERINCLUSAO' 	=>$CDOPERINCLUSAO, 
			':NRORGULTATU' 		=>$NRORGULTATU, 
			':CDOPERULTATU' 	=>$CDOPERULTATU
		);
		
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERT_DATA_UTIL_BENEFEICIO, $params);
	}

	public function verificarBENEFICIOCAMP($CDCAMPANHA){
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA,
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::VERIFICAR_BENEFICIOCAMP, $params);
	}

	public function bloquearCartao($CDIDCONSUMID){
		$params = array(
			':CDIDCONSUMID' => $CDIDCONSUMID
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::BLOQUEAR_CARTAO, $params);
	}

	public function verificarCartao($CDIDCONSUMID){
		$params = array(
			':CDIDCONSUMID' => $CDIDCONSUMID
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::VERIFICAR_CARTAO, $params);
	}	

	public function buscaProdCampanhaBeneficio($CDCAMPANHA){
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA,
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_PROD_CAMP_BEN, $params);
	}

	public function buscaBeneficiosDisponiveis($CDCAMPANHA, $CDCLIENTE, $CDCONSUMIDOR, $NRSEQPRODCAMP){
		$params = array(
			':CDCAMPANHA' => $CDCAMPANHA, 
			':CDCLIENTE' => $CDCLIENTE, 
			':CDCONSUMIDOR' => $CDCONSUMIDOR, 
			':NRSEQPRODCAMP' => $NRSEQPRODCAMP
		);

		$result = $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_BENEFICIO_DISPONIVEL, $params);
		return $result;
	}

	public function checkUtilControlBeneficio($CDCLIENTE, $CDCONSUMIDOR, $CDCAMPANHA, $NRSEQPRODCAMP, $NRSEQBENEFICIO){
		$params = array(			
			':CDCLIENTE' 	  => $CDCLIENTE, 
			':CDCONSUMIDOR'   => $CDCONSUMIDOR,
			':CDCAMPANHA' 	  => $CDCAMPANHA, 
			':NRSEQPRODCAMP'  => $NRSEQPRODCAMP,
			':NRSEQBENEFICIO' => $NRSEQBENEFICIO
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::CHECK_BENEFICIO_MOVBENEFICIOCTR, $params);
	}

	public function insereManutencaoBeneficio($CDCAMPANHA, $CDCLIENTE, $CDCONSUMIDOR, $DTFIMVALBENECONS, $IDTPBENEFICIO, $NRSEQBENEFICIO, $QTDEBENEFICIO, $VRBENEFICIO, $NRSEQPRODCAMP, $NRORG, $NRORGINCLUSAO, $CDOPERINCLUSAO, $NRORGULTATU, $CDOPERULTATU){		
		$params = array(			
			':CDCAMPANHA' 		=> $CDCAMPANHA, 
			':CDCLIENTE' 		=> $CDCLIENTE, 
			':CDCONSUMIDOR' 	=> $CDCONSUMIDOR, 
			':DTFIMVALBENECONS' => $DTFIMVALBENECONS,			
			':IDTPDESBENECONS' 	=> $IDTPBENEFICIO, 
			':NRSEQBENEFICIO' 	=> $NRSEQBENEFICIO, 
			':QTDEBENEFICIO' 	=> $QTDEBENEFICIO, 
			':VRDESBENECONS' 	=> $VRBENEFICIO, 
			':NRSEQPRODCAMP' 	=> $NRSEQPRODCAMP, 
			':NRORG' 			=> $NRORG, 
			':NRORGINCLUSAO' 	=> $NRORGINCLUSAO, 
			':CDOPERINCLUSAO' 	=> $CDOPERINCLUSAO, 
			':NRORGULTATU' 		=> $NRORGULTATU, 
			':CDOPERULTATU' 	=> $CDOPERULTATU
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERE_BENEFICIO_MOVBENEFICIOCTR, $params);
	}
	public function insereBeneficioDoacao($CDCAMPANHA, $CDCLIENTE, $CDCONSUMIDOR, $DTFIMVALBENECONS, $IDTPBENEFICIO, $NRSEQBENEFICIO, $QTDEBENEFICIO, $VRBENEFICIO, $NRSEQPRODCAMP, $NRORG, $NRORGINCLUSAO, $CDOPERINCLUSAO, $NRORGULTATU, $CDOPERULTATU,$IDIMPTMOVCTR){		
		$params = array(			
			':CDCAMPANHA' 		=> $CDCAMPANHA, 
			':CDCLIENTE' 		=> $CDCLIENTE, 
			':CDCONSUMIDOR' 	=> $CDCONSUMIDOR, 
			':DTFIMVALBENECONS' => $DTFIMVALBENECONS,			
			':IDTPDESBENECONS' 	=> $IDTPBENEFICIO, 
			':NRSEQBENEFICIO' 	=> $NRSEQBENEFICIO, 
			':QTDEBENEFICIO' 	=> $QTDEBENEFICIO, 
			':VRDESBENECONS' 	=> $VRBENEFICIO, 
			':NRSEQPRODCAMP' 	=> $NRSEQPRODCAMP, 
			':NRORG' 			=> $NRORG, 
			':NRORGINCLUSAO' 	=> $NRORGINCLUSAO, 
			':CDOPERINCLUSAO' 	=> $CDOPERINCLUSAO, 
			':NRORGULTATU' 		=> $NRORGULTATU, 
			':CDOPERULTATU' 	=> $CDOPERULTATU,
			':IDIMPTMOVCTR' 	=> $IDIMPTMOVCTR
			
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERE_BENEFICIO_DOACAO, $params);
	}

	public function verificaMovimentacao($CDCAMPANHA){
		$params = array(			
			':CDCAMPANHA' 		=> $CDCAMPANHA
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::VERIFICA_MOVBENEFICIOCTR, $params);
	}

	public function updateManutencaoBeneficio($QTDEBENEFICIO, $NRORGULTATU, $CDOPERULTATU, $CDCAMPANHA, $CDCLIENTE, $CDCONSUMIDOR, $NRSEQPRODCAMP, $NRSEQBENEFICIO){
		$params = array(
			':QTDEBENEFICIO'  => $QTDEBENEFICIO,
			':NRORGULTATU' 	  => $NRORGULTATU,
			':CDOPERULTATU'   => $CDOPERULTATU,
			':CDCAMPANHA' 	  => $CDCAMPANHA,
			':CDCLIENTE' 	  => $CDCLIENTE,
			':CDCONSUMIDOR'   => $CDCONSUMIDOR,
			':NRSEQPRODCAMP'  => $NRSEQPRODCAMP,
			':NRSEQBENEFICIO' => $NRSEQBENEFICIO
		);		

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_BENEFICIO_MOVBENEFICIOCTR, $params);
	}

	public function buscaDiasValidadben($CDCAMPANHA, $NRSEQPRODCAMP, $NRSEQBENEFICIO){
		$params = array(
			':CDCAMPANHA' 	  =>$CDCAMPANHA, 
			':NRSEQPRODCAMP'  =>$NRSEQPRODCAMP, 
			':NRSEQBENEFICIO' =>$NRSEQBENEFICIO
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_VALIDADE_BENEFICIO, $params);
	}
	
	public function buscaMecanica($CDCAMPANHA){
		
		$params = array(
			':CDCAMPANHA' 	  =>$CDCAMPANHA, 			
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_MECANICA, $params);
	}

	public function paramFidelidadeGeral($CDCLIENTEFD, $CDTIPOCONSFD, $CDCCUSCLIEFD){
		$params = array(
			':CDCLIENTEFD'  =>$CDCLIENTEFD, 
			':CDTIPOCONSFD' =>$CDTIPOCONSFD,
			':CDCCUSCLIEFD' =>$CDCCUSCLIEFD			
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_FIDELIDADE_PARAMGERAL, $params);
	}

	public function buscaParamGeralFidelidade($NRORG){
		$params = array(
			':NRORG'  =>$NRORG		
		);
		return $this->entityManager->getConnection()->fetchAll(self::BUSCA_PARAMGERAL_FIDELIDADE, $params);
	}
	//Doação de cartões
	public function criaCartaoDoacao($params){
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_CARTAO_DOACAO, $params);
	}

	public function getCartoes(){
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_CARTOES);
	}
	public function getTipoConsFidelity(){
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_TIPO_CONSUMIDOR_FIDELITY);
	}

	public function updateBenefitExpiration($CDCLIENTE, $CDCONSUMIDOR, $CDCAMPANHA, $NRSEQBENEFICIO, $DTINIVALBENECONS, $DTFIMVALBENECONS){
		$params = array(
			':CDCLIENTE' => $CDCLIENTE,
			':CDCONSUMIDOR' => $CDCONSUMIDOR,
			':CDCAMPANHA' => $CDCAMPANHA,
			':NRSEQBENEFICIO' => $NRSEQBENEFICIO,
			':DTINIVALBENECONS' => $DTINIVALBENECONS,
			':DTFIMVALBENECONS' => $DTFIMVALBENECONS
		);
		$this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_BENEFIT_EXPIRATION, $params);
	}

	public function alteraDsbeneficioQtdmaxdiasubseqQtdmaxdiacompra($NRSEQBENEFICIO, $DSBENEFICIO, $QTDMAXDIACOMPRA, $QTDMAXDIASUBSEQ){
		$params = array(
			':NRSEQBENEFICIO'  => $NRSEQBENEFICIO,
			':DSBENEFICIO'     => $DSBENEFICIO,
			':QTDMAXDIACOMPRA' => $QTDMAXDIACOMPRA,
			':QTDMAXDIASUBSEQ' => $QTDMAXDIASUBSEQ
		);
		$this->entityManager->getConnection()->executeQuery(Utilities\Query::ALTERA_DSBENEFICIO_QTDMAXDIASUBSEQ_QTDMAXDIACOMPRA, $params);
	}
	
	public function buscaBeneficiosCamp($NRORG, $CDCAMPANHA,$CDCONSUMIDOR, $CDCLIENTE){
		$params = array (
				':NRORG'        => $NRORG,
				':CDCLIENTE'    => $CDCLIENTE,
				':CDCAMPANHA'   => $CDCAMPANHA,
				':CDCONSUMIDOR' => $CDCONSUMIDOR
			);
		return $this->entityManager->getConnection()->fetchAll(self::BUSCA_BENEFICIO_PROD_CAMP, $params);	
	}
	
	public function findNomeCampanha($NRORG){
		$params = array (
				':NRORG'        => $NRORG
			);
		return $this->entityManager->getConnection()->fetchAll(self::GET_NOME_CAMPANHA, $params);	
	}

	public function saveParamGeralFidelidade($NRORG, $CDTIPOCONS, $CDCLIENTE, $CDCCUSCLIE){
		$params = array (
			':NRORG'        => $NRORG,
			':CDCLIENTE'    => $CDCLIENTE,
			':CDTIPOCONS'   => $CDTIPOCONS,
			':CDCCUSCLIE'	=> $CDCCUSCLIE
		);
	}
	
	public function getProdutosContemplados($CDPRODUTOINI, $CDPRODUTOFIN, $NRORG){
		$params = array (
			':CDPRODUTOINI' => $CDPRODUTOINI,
			':CDPRODUTOFIN' => $CDPRODUTOFIN,
			':NRORG' => $NRORG
		);
		return $this->entityManager->getConnection()->fetchAll(self::GET_PRODUTOS_CONTEMPLADOS, $params);	
	}
	
	
	public function getProductsBetweenTwo($row){
		$params = array(
			':CDARVPRODINI' => $row['CDARVPRODINI'],
			':CDARVPRODFIN' => $row['CDARVPRODFIN'],
			':CDCAMPANHA'   => $row['CDCAMPANHA'],
			':NRORG'        => $row['NRORG']
		);
		
		return $this->entityManager->getConnection()->fetchAll(self::GET_PRODUCTS_BETWEEN_TWO, $params);
	}

	const GET_PRODUTOS_CONTEMPLADOS = "
		SELECT CDPRODUTO 
		  FROM PRODUTO
		 WHERE CDARVPROD BETWEEN :CDPRODUTOINI AND :CDPRODUTOFIN
		   AND CDNVPRODUTO = (SELECT DISTINCT MAX(CDNVPRODUTO) FROM PRODUTO)
	";
	
	const BUSCA_CAMPANHA_BENEFICIOS_MANUTENCAO = "
	SELECT DISTINCT C.CDCAMPANHA, C.DSCAMPANHA, C.IDCAMPANHA, CO.CDCONSUMIDOR, CO.CDCLIENTE, C.NRORG
     FROM CAMPANHA C
     JOIN MOVBENEFICIOCTR M
       ON C.CDCAMPANHA = M.CDCAMPANHA
      AND C.NRORG = M.NRORG
     JOIN CONSUMIDOR CO
       ON M.CDCONSUMIDOR = CO.CDCONSUMIDOR 
      AND M.CDCLIENTE = CO.CDCLIENTE
      AND M.NRORG = CO.NRORG
    WHERE M.CDCONSUMIDOR = :CDCONSUMIDOR
      AND M.CDCLIENTE = :CDCLIENTE
      AND M.NRORG = :NRORG 
    
	UNION
      
    SELECT DISTINCT C.CDCAMPANHA, C.DSCAMPANHA, C.IDCAMPANHA, CO.CDCONSUMIDOR, CO.CDCLIENTE, C.NRORG
     FROM CAMPANHA C
     JOIN MOVBENEFICIOCONS M
       ON C.CDCAMPANHA = M.CDCAMPANHA
      AND C.NRORG = M.NRORG
     JOIN CONSUMIDOR CO
       ON M.CDCONSUMIDOR = CO.CDCONSUMIDOR 
      AND M.CDCLIENTE = CO.CDCLIENTE
      AND M.NRORG = CO.NRORG
    WHERE M.CDCONSUMIDOR = :CDCONSUMIDOR
      AND M.CDCLIENTE = :CDCLIENTE
      AND M.NRORG = :NRORG 
    ORDER BY CDCAMPANHA
	";
	
	const BUSCA_BENEFICIO_PROD_CAMP = "
         SELECT DISTINCT BC.CDCAMPANHA, BC.NRSEQBENEFICIO, BC.NRSEQPRODCAMP, BC.QTBENEFICIOCAMP, BF.IDTPBENEFICIO,
         (CASE BF.IDTPBENEFICIO  WHEN 'P' THEN 'Percentual' WHEN 'V' THEN 'Valor' END) AS NMTPBENEFICIO,
         BF.VRBENEFICIO, BC.NRDIASVALBENECAMP, BF.IDTPATIVABENEFICIO, PC.CDPRODUTO, BC.NRORG, BF.DSBENEFICIO, P.NMPRODUTO
    FROM BENEFICIOCAMP BC
    JOIN BENEFICIOFOS BF
      ON BC.NRSEQBENEFICIO = BF.NRSEQBENEFICIO
     AND BC.NRORG = BF.NRORG
    JOIN PRODCAMPANHA PC
      ON BC.CDCAMPANHA = PC.CDCAMPANHA
     AND BC.NRSEQPRODCAMP = PC.NRSEQPRODCAMP
     AND BC.NRORG = PC.NRORG
    JOIN PRODUTO P
      ON PC.CDPRODUTO = P.CDPRODUTO
     AND PC.NRORG = P.NRORG
   WHERE BC.NRORG = :NRORG
     AND BC.CDCAMPANHA = :CDCAMPANHA
     AND BC.NRSEQBENEFICIO||BC.NRSEQPRODCAMP NOT IN (SELECT NRSEQBENEFICIO||NRSEQPRODCAMP FROM MOVBENEFICIOCTR WHERE CDCLIENTE = :CDCLIENTE AND CDCONSUMIDOR = :CDCONSUMIDOR)
     ORDER BY BC.NRSEQBENEFICIO, BC.NRSEQPRODCAMP";
     
    const GET_NOME_CAMPANHA = "
		  SELECT CDCAMPANHA, DSCAMPANHA
			FROM CAMPANHA
		  WHERE NRORG = :NRORG
	";

	const BUSCA_PARAMGERAL_FIDELIDADE = "
        SELECT P.CDCLIENTEFD AS CDCLIENTE, P.CDTIPOCONSFD AS CDTIPOCONS, P.CDCCUSCLIEFD, C.NMRAZSOCCLIE, T.NMTIPOCONS, E.NMCCUSCLIE,
               P.CDCLIENTEFD  || ' - ' || C.NMRAZSOCCLIE AS CLIENTESELECAO,
               P.CDTIPOCONSFD || ' - ' || T.NMTIPOCONS AS TIPOCONSSELECAO,
               P.CDCLIENTEFD  || ' - ' || E.NMCCUSCLIE AS CCUSCLIESELECAO,
               P.NRORG
          FROM PARAMGERAL P, TIPOCONS T, CLIENTE C, CCUSCLIE E
         WHERE P.CDTIPOCONSFD = T.CDTIPOCONS
           AND P.CDCLIENTEFD = C.CDCLIENTE
           AND P.CDCCUSCLIEFD = E.CDCCUSCLIE
           AND P.CDCLIENTEFD = E.CDCLIENTE
           AND P.NRORG = :NRORG
           AND T.NRORG = P.NRORG
           AND C.NRORG = P.NRORG
           AND E.NRORG = P.NRORG
         AND P.CDCLIENTEFD = E.CDCLIENTE
    ";
    
    const GET_PRODUCTS_BETWEEN_TWO = "
    	SELECT
		    CDPRODUTO
		FROM
		    PRODUTO
		WHERE
		    CDARVPROD BETWEEN :CDARVPRODINI AND :CDARVPRODFIN
		    AND   CDNVPRODUTO = (SELECT MAX(CDNVPRODUTO) FROM PRODUTO)
		    AND   CDARVPROD NOT IN (
		        SELECT
		            P.CDARVPROD
		        FROM
		            PRODUTO P,
		            PRODCAMPANHA C
		        WHERE
		            C.CDCAMPANHA = :CDCAMPANHA
		            AND   P.CDPRODUTO = C.CDPRODUTO
		            AND   P.NRORG = :NRORG
		    )
		ORDER BY
		    CDARVPROD
    ";
}